ToraRange_Radar = {}
ToraRange_Radar.Icons = {}
ToraRange_Radar.RaidIcons = {}
ToraRange_Radar.CurrentIndex = 1

function ToraRange_Radar:Reset()
	for i, icon in pairs(self.Icons) do
		icon:Hide()
	end

	for i, raidIcon in pairs(self.RaidIcons) do
		raidIcon:Hide()
	end

	self.CurrentIndex = 1
end

function ToraRange_Radar:Add(x, y, color)
	local scaledX, scaledY = ToraRange_Options_RadarScale * x, ToraRange_Options_RadarScale * y

	-- Do nothing if the icon would be outside of the window
	if scaledX < -self.Frame:GetWidth()/2 or scaledX > self.Frame:GetWidth()/2 or
	   scaledY < -self.Frame:GetHeight()/2 or scaledY > self.Frame:GetHeight()/2 then
	   return
   end 

	-- Update the color icon
	local icon = self.Icons[self.CurrentIndex]
	icon:SetPoint("CENTER", scaledX, scaledY)

	if color then
		icon:SetColorTexture(color.r, color.g, color.b, color.a)
	end

	icon:Show()

	-- Update the raid icon
	if color and color.IconIndex then
		local raidIcon = self.RaidIcons[self.CurrentIndex]
		raidIcon:SetPoint("CENTER", scaledX, scaledY)
		raidIcon:SetTexture(string.format("Interface/TARGETINGFRAME/UI-RaidTargetingIcon_%d", color.IconIndex))
		raidIcon:Show()
	end

	self.CurrentIndex = self.CurrentIndex + 1
end

function ToraRange_Radar:OnLoad(frame)
	self.Frame = frame

	-- Add background
	local tex = self.Frame:CreateTexture("ARTWORK")
	tex:SetAllPoints()
	tex:SetColorTexture(0, 0, 0, 0.2)

	-- Create the icons
	self.Frame.Icons = {}
	for i = 1, 40 do
		local icon = self.Frame:CreateTexture(nil, "BACKGROUND")
		icon:SetColorTexture(1.0, 0, 0, 0.8)
		icon:SetPoint("CENTER", 0, 0)
		icon:SetSize(8, 8)
		icon:Hide()

		table.insert(self.Icons, icon)

		local raidIcon = self.Frame:CreateTexture(nil, "LOW")
		raidIcon:SetColorTexture(1.0, 0, 0, 0.8)
		raidIcon:SetPoint("CENTER", 0, 0)
		raidIcon:SetSize(8, 8)
		raidIcon:Hide()

		table.insert(self.RaidIcons, raidIcon)
	end

	self.Frame:Show()
end
